-- v1.3 adds the right-click to cast Conjure Refreshment feature
--create the main frame
local MageFood = CreateFrame("FRAME", "MageFood", UIParent)
MageFood:RegisterEvent("PLAYER_ENTERING_WORLD")
MageFood:RegisterEvent("BAG_UPDATE")
MageFood:RegisterEvent("CHAT_MSG_LOOT")
MageFood:RegisterEvent("UNIT_AURA")
MageFood:RegisterEvent("PLAYER_REGEN_ENABLED")
MageFood:SetScript("OnEvent", function(self, event, ...) self:OnEvent(event, ...) end)
local MageCombatDelayedEvent = FALSE;
local MageIsInWorld = FALSE;
local MageFoodCurrent = "";
local MageFritter = 0;
local MagePudding = 0;
local MageCake = 0;
local MageStrudel = 0;
local MagePie = 0;
local MageLollipop = 0;
local MageCupcake = 0;
local MageBrownie = 0;
local MageCookie = 0;

function MageFoodCount()
	MageFritter = GetItemCount(113509); --GetItemCount("Conjured Mana Fritter");
	MagePudding = GetItemCount(80610); --GetItemCount("Conjured Mana Pudding");
	MageCake = GetItemCount(65499); --GetItemCount("Conjured Mana Cake");
	MageStrudel = GetItemCount(43523); --GetItemCount("Conjured Mana Strudel");
	MagePie = GetItemCount(43518); --GetItemCount("Conjured Mana Pie");
	MageLollipop = GetItemCount(65517); --GetItemCount("Conjured Mana Lollipop");
	MageCupcake = GetItemCount(65516); --GetItemCount("Conjured Mana Cupcake");
	MageBrownie = GetItemCount(65515); --GetItemCount("Conjured Mana Brownie");
	MageCookie = GetItemCount(65500); --GetItemCount("Conjured Mana Cookie");
end

function MageMacroCreate()
	if (MageFoodCurrent == nil) then
		MageFoodCurrent = "";
	end
	if (MageFritter > 0) then
		MageFoodCurrent = GetItemInfo(113509); --"Conjured Mana Fritter";
	elseif (MagePudding > 0) then
		MageFoodCurrent = GetItemInfo(80610); --"Conjured Mana Pudding";
	elseif (MageCake > 0) then
		MageFoodCurrent = GetItemInfo(65499); --"Conjured Mana Cake";
	elseif (MageStrudel > 0) then
		MageFoodCurrent = GetItemInfo(43523); --"Conjured Mana Strudel";
	elseif (MagePie > 0) then
		MageFoodCurrent = GetItemInfo(43518); --"Conjured Mana Pie";
	elseif (MageLollipop > 0) then
		MageFoodCurrent = GetItemInfo(65517); --"Conjured Mana Lollipop";
	elseif (MageCupcake > 0) then
		MageFoodCurrent = GetItemInfo(65516); --"Conjured Mana Cupcake";
	elseif (MageBrownie > 0) then
		MageFoodCurrent = GetItemInfo(65515); --"Conjured Mana Brownie";
	elseif (MageCookie > 0) then
		MageFoodCurrent = GetItemInfo(65500); --"Conjured Mana Cookie";
	end
	local CfoodSpell = GetSpellInfo(42955);
	local CfoodIdx = GetMacroIndexByName("MageFoodMac");
	local magebutton = "";
-- The magebutton line below was added to allow the MageFoodMac to cast Conjure Refreshment if you right-click it.
-- If you don't like this, then you can comment the below line by adding two dashes at the front just like at the front of this one.
	magebutton = "[btn:1/3] ";	-- Comment this line out by putting two dashes at the beginning of the line to not use the right-click cast option
	local mageline1 = "#showtooltip\n";
	local mageline2 = "/use "..magebutton..MageFoodCurrent.."\n";
	local mageline3 = "";
-- The mageline3 line below was added to allow the MageFoodMac to cast Conjure Refreshment if you right-click it.
-- If you don't like this, then you can comment the below line by adding two dashes at the front just like at the front of this one.
	mageline3 = "/cast [nobtn:1/3] "..CfoodSpell;	-- Comment this line out by putting two dashes at the beginning of the line to not use the right-click cast option
	if (CfoodIdx == 0) then
		local macroId = CreateMacro("MageFoodMac", "INV_MISC_QUESTIONMARK", mageline1..mageline2..mageline3, nil);
	else
		local macroId = EditMacro(CfoodIdx, "MageFoodMac", "INV_MISC_QUESTIONMARK", mageline1..mageline2..mageline3)
	end
end

function MageFood:OnEvent(event, ...)
	if (not InCombatLockdown()) then
		if (MageCombatDelayedEvent==TRUE) then
			if (event=="PLAYER_REGEN_ENABLED") then
				MageCombatDelayedEvent = FALSE;
				if (GetItemCount(MageFoodCurrent)<1) then
					MageFoodCount();
					MageMacroCreate();
				end
			end
		end
		if (event=="PLAYER_ENTERING_WORLD") then
			MageIsInWorld = TRUE;
			if (GetItemCount(MageFoodCurrent)<1) then
				MageFoodCount();
				MageMacroCreate();
			end
		elseif (event=="BAG_UPDATE" and MageIsInWorld==TRUE) then
			if (GetItemCount(MageFoodCurrent)<1) then
				MageFoodCount();
				MageMacroCreate();
			end
		elseif (event=="CHAT_MSG_LOOT") then
			local arg1 = ...
			if (GetItemCount(MageFoodCurrent)<1) then
				MageFoodCount();
				MageMacroCreate();
			end
		elseif (event=="UNIT_AURA") then
			local arg1 = ...
			if (arg1=="player") then
				if (GetItemCount(MageFoodCurrent)<1) then
					MageFoodCount();
					MageMacroCreate();
				end
			end
		end
	end
end
